<?php

namespace Toalett\Redis\Timeseries\Model;

final class Range
{
    private string $key;
    private array $labels;
    private array $values;

    public function __construct(string $key, array $labels, array $values)
    {
        $this->key = $key;
        $this->labels = $labels;
        $this->values = $values;
    }

    public function getKey(): string
    {
        return $this->key;
    }

    public function getLabels(): array
    {
        return $this->labels;
    }

    /**
     * @return Value[]
     */
    public function getValues(): array
    {
        return $this->values;
    }
}
