<?php

namespace Toalett\Redis\Timeseries\Protocol\Command;

use Toalett\Redis\Timeseries\Model\Value;
use Toalett\Redis\Timeseries\Protocol\Command\Components\CommandAssembler;
use Toalett\Redis\Timeseries\Protocol\Command\Components\ContainsKey;
use Toalett\Redis\Timeseries\Protocol\Command\Components\ContainsValue;

class AddCommand implements Command
{
    use ContainsKey;
    use ContainsValue;
    use CommandAssembler;

    public function __construct(string $key, Value $value)
    {
        $this->key = $key;
        $this->value = $value;
    }

    public function toRawCommand(): array
    {
        return $this->assemble('TS.ADD');
    }
}
