<?php

namespace Toalett\Redis\Timeseries\Protocol\Command\Components;

use Toalett\Redis\Timeseries\Model\Retention;

trait ContainsRetention
{
    protected ?Retention $retention = null;

    public function retain(Retention $retention): self
    {
        $this->retention = $retention;
        return $this;
    }

    protected function appendRetention(array $command): array
    {
        if (!is_null($this->retention)) {
            $command[] = 'RETENTION';
            $command[] = $this->retention->getValue();
        }
        return $command;
    }
}
