<?php

namespace Toalett\Redis\Timeseries\Protocol\Command;

use Toalett\Redis\Timeseries\Model\Aggregation;
use Toalett\Redis\Timeseries\Protocol\Command\Components\CommandAssembler;
use Toalett\Redis\Timeseries\Protocol\Command\Components\ContainsAggregation;
use Toalett\Redis\Timeseries\Protocol\Command\Components\ContainsSourceAndDestinationKeys;

class CreateRuleCommand implements Command
{
    use ContainsSourceAndDestinationKeys;
    use ContainsAggregation;
    use CommandAssembler;

    public function __construct(string $sourceKey, string $destinationKey, Aggregation $aggregation)
    {
        $this->setEndpoints($sourceKey, $destinationKey);
        $this->aggregate($aggregation);
    }

    public function toRawCommand(): array
    {
        return $this->assemble('TS.CREATERULE');
    }
}
