<?php

namespace Toalett\Redis\Timeseries\Protocol\Query\Components;

use Toalett\Redis\Timeseries\Exception\InvalidArgumentException;

trait ContainsRange
{
    protected string $from = '-';
    protected string $to = '+';

    /**
     * @param int|string $fromTimestamp
     * @param int|string $toTimestamp
     * @return $this
     */
    protected function range($fromTimestamp, $toTimestamp): self
    {
        if ($fromTimestamp < 0 && $fromTimestamp !== '-') {
            throw new InvalidArgumentException("fromTimestamp must be '-' or  positive integer");
        }
        if ($toTimestamp < 0 && $toTimestamp !== '+') {
            throw new InvalidArgumentException("toTimestamp must be '+' or  positive integer");
        }
        $this->from = $fromTimestamp;
        $this->to = $toTimestamp;

        return $this;
    }

    protected function appendRange(array $command): array
    {
        $command[] = $this->from;
        $command[] = $this->to;

        return $command;
    }
}
